commit e8acf6816cf360d5db0ebfaf995415961f455274
Author: Gaius Mulley <gaiusmod2@gmail.com>
Date:   Tue Dec 3 13:37:01 2024 +0000

    [PATCH] PR modula2/115328 The FORWARD keyword is not implemented
    
    This patch implements the FORWARD keyword found in the ISO standard.
    The patch checks incoming parameters against the prior declaration
    found in definition/forward sections and will issue an error based
    on virtual tokens highlighing the full parameter declaration.
    
    gcc/m2/ChangeLog:
    
            PR modula2/115328
            * gm2-compiler/M2MetaError.def: Extend comment documentating
            new format specifiers.
            * gm2-compiler/M2MetaError.mod (GetTokProcedure): New declaration.
            (doErrorScopeModule): New procedure.
            (doErrorScopeForward): Ditto.
            (doErrorScopeMod): Reimplement.
            (doErrorScopeFor): New procedure.
            (declarationMod): Ditto.
            (doErrorScopeDefinition): Ditto.
            (doErrorScopeDef): Reimplement.
            (declaredDef): New procedure.
            (declaredFor): Ditto.
            (doErrorScopeProc): Ditto.
            (declaredVar): Ditto.
            (declaredType): Ditto.
            (declaredFull): Ditto.
            * gm2-compiler/M2Options.mod (SetAutoInit): Add missing
            return type.
            (GetDumpGimple): Remove duplicate implementation.
            * gm2-compiler/M2Quads.def (DupFrame): New procedure.
            * gm2-compiler/M2Quads.mod (DupFrame): New procedure.
            * gm2-compiler/M2Reserved.def (ForwardTok): New variable.
            * gm2-compiler/M2Reserved.mod (ForwardTok): Initialize variable.
            * gm2-compiler/M2Scaffold.mod (DeclareArgEnvParams): Add
            tokno parameter for call to PutParam.
            * gm2-compiler/P0SymBuild.def (EndForward): New procedure.
            * gm2-compiler/P0SymBuild.mod (EndForward): New procedure.
            * gm2-compiler/P0SyntaxCheck.bnf (BlockAssert): New procedure.
            (ProcedureDeclaration): Reimplement rule.
            (PostProcedureHeading): New rule.
            (ForwardDeclaration): Ditto.
            (ProperProcedure): Ditto.
            * gm2-compiler/P1Build.bnf (ProcedureDeclaration): Reimplement rule.
            (PostProcedureHeading): New rule.
            (ForwardDeclaration): Ditto.
            (ProperProcedure): Ditto.
            * gm2-compiler/P1SymBuild.def (Export): Removed unnecessary
            export.
            (EndBuildForward): New procedure.
            * gm2-compiler/P1SymBuild.mod (StartBuildProcedure): Reimplement.
            (EndBuildProcedure): Ditto.
            (EndBuildForward): Ditto.
            * gm2-compiler/P2Build.bnf (ProcedureDeclaration): Reimplement rule.
            (PostProcedureHeading): New rule.
            (ForwardDeclaration): Ditto.
            (ProperProcedure): Ditto.
            * gm2-compiler/P2SymBuild.def (BuildProcedureDefinedByForward):
            New procedure.
            (BuildProcedureDefinedByProper): Ditto.
            (CheckProcedure): Ditto.
            (EndBuildForward): Ditto.
            * gm2-compiler/P2SymBuild.mod (EndBuildProcedure): Reimplement.
            (EndBuildForward): New procedure.
            (BuildFPSection): Reimplement to allow forward declaration or
            checking of parameters.
            (BuildProcedureDefinedByProper): New procedure.
            (BuildProcedureDefinedByForward): Ditto
            (FailParameter): Remove.
            (ParameterError): New procedure.
            (ParameterMismatch): Ditto.
            (EndBuildFormalParameters): Add parameter number check.
            (GetComparison): New procedure function.
            (GetSourceDesc): Ditto.
            (GetCurSrcDesc): Ditto.
            (GetDeclared): New procedure.
            (ReturnTypeMismatch): Ditto.
            (BuildFunction): Reimplement.
            (CheckProcedure): New procedure.
            (CheckFormalParameterSection): Reimplement using ParameterError.
            * gm2-compiler/P3Build.bnf (ProcedureDeclaration): Reimplement rule.
            (PostProcedureHeading): New rule.
            (ForwardDeclaration): Ditto.
            (ProperProcedure): Ditto.
            * gm2-compiler/P3SymBuild.def (Export): Remove unnecessary export.
            (EndBuildForward): New procedure.
            * gm2-compiler/P3SymBuild.mod (EndBuildForward): New procedure.
            * gm2-compiler/PCBuild.bnf (ProcedureDeclaration): Reimplement rule.
            (PostProcedureHeading): New rule.
            (ForwardDeclaration): Ditto.
            (ProperProcedure): Ditto.
            * gm2-compiler/PCSymBuild.def (EndBuildForward): New procedure.
            * gm2-compiler/PCSymBuild.mod (EndBuildForward): Ditto.
            * gm2-compiler/PHBuild.bnf (ProcedureDeclaration): Reimplement rule.
            (PostProcedureHeading): New rule.
            (ForwardDeclaration): Ditto.
            (ProperProcedure): Ditto.
            * gm2-compiler/SymbolTable.def (PutVarTok): New procedure.
            (PutParam): Add typetok parameter.
            (PutVarParam): Ditto.
            (PutParamName): Ditto.
            (GetDeclaredFor): New procedure function.
            (AreParametersDefinedInDefinition): Ditto.
            (PutParametersDefinedByForward): New procedure.
            (GetParametersDefinedByForward): New procedure function.
            (PutParametersDefinedByProper): New procedure.
            (GetParametersDefinedByProper): New procedure function.
            (GetProcedureDeclaredForward): Ditto.
            (PutProcedureDeclaredForward): New procedure.
            (GetProcedureDeclaredProper): New procedure function.
            (PutProcedureDeclaredProper): New procedure.
            (GetProcedureDeclaredDefinition): New procedure function.
            (PutProcedureDeclaredDefinition): New procedure.
            (GetVarDeclTypeTok): Ditto.
            (PutVarDeclTypeTok): New procedure.
            (GetVarDeclTok): Ditto.
            (PutVarDeclTok): New procedure.
            (GetVarDeclFullTok): Ditto.
            * gm2-compiler/SymbolTable.mod (ProcedureDecl): New record type.
            (VarDecl): Ditto.
            (SymProcedure): Add new field Declared.
            (SymVar): Add new field Declared.
            (PutVarTok): New procedure.
            (PutParam): Add typetok parameter.
            (PutVarParam): Ditto.
            (PutParamName): Ditto.
            (GetDeclaredFor): New procedure function.
            (AreParametersDefinedInDefinition): Ditto.
            (PutParametersDefinedByForward): New procedure.
            (GetParametersDefinedByForward): New procedure function.
            (PutParametersDefinedByProper): New procedure.
            (GetParametersDefinedByProper): New procedure function.
            (GetProcedureDeclaredForward): Ditto.
            (PutProcedureDeclaredForward): New procedure.
            (GetProcedureDeclaredProper): New procedure function.
            (PutProcedureDeclaredProper): New procedure.
            (GetProcedureDeclaredDefinition): New procedure function.
            (PutProcedureDeclaredDefinition): New procedure.
            (GetVarDeclTypeTok): Ditto.
            (PutVarDeclTypeTok): New procedure.
            (GetVarDeclTok): Ditto.
            (PutVarDeclTok): New procedure.
            (GetVarDeclFullTok): Ditto.
            (MakeProcedure): Initialize Declared field.
            (MakeVar): Initialize Declared field.
            * gm2-libs-log/FileSystem.def (FileNameChar): Add
            missing return type.
            * m2.flex: Add FORWARD keyword.
    
    gcc/testsuite/ChangeLog:
    
            PR modula2/115328
            * gm2/iso/fail/badparam.def: New test.
            * gm2/iso/fail/badparam.mod: New test.
            * gm2/iso/fail/badparam2.def: New test.
            * gm2/iso/fail/badparam2.mod: New test.
            * gm2/iso/fail/badparam3.def: New test.
            * gm2/iso/fail/badparam3.mod: New test.
            * gm2/iso/fail/badparamarray.def: New test.
            * gm2/iso/fail/badparamarray.mod: New test.
            * gm2/iso/fail/simpledef1.def: New test.
            * gm2/iso/fail/simpledef1.mod: New test.
            * gm2/iso/fail/simpleforward.mod: New test.
            * gm2/iso/fail/simpleforward2.mod: New test.
            * gm2/iso/fail/simpleforward3.mod: New test.
            * gm2/iso/fail/simpleforward4.mod: New test.
            * gm2/iso/fail/simpleforward5.mod: New test.
            * gm2/iso/fail/simpleforward7.mod: New test.
            * gm2/iso/pass/simpleforward.mod: New test.
            * gm2/iso/pass/simpleforward6.mod: New test.
    
    (cherry picked from commit e751639e3d20efe97186faa7dca33e7761ba1e79)
    
    Signed-off-by: Gaius Mulley <gaiusmod2@gmail.com>

diff --git a/gcc/m2/gm2-compiler/M2MetaError.def b/gcc/m2/gm2-compiler/M2MetaError.def
index 792f4a54c9a..c83770a4403 100644
--- a/gcc/m2/gm2-compiler/M2MetaError.def
+++ b/gcc/m2/gm2-compiler/M2MetaError.def
@@ -69,11 +69,23 @@ EXPORT QUALIFIED MetaError0, MetaError1, MetaError2, MetaError3, MetaError4,
     {%1D}     sets the error message to where symbol 1 was declared.
               The declaration will choose the definition module, then
               implementation (or program) module.
+    {%1G}     sets the error message to where symbol 1 was declared.
+              The declaration will choose in order the forward declaration,
+              implementation module, program module or definition module.
     {%1M}     sets the error message to where symbol 1 was declared.
               The declaration will choose the implementation or program
               module and if these do not exist then it falls back to
               the definition module.
     {%1U}     sets the error message to where symbol 1 was first used.
+    {%1V}     set the error message location to the name of the symbol declared.
+              For example foo: bar
+                          ^^^  some error message.
+    {%1H}     set the error message location to the whole declaration of the symbol.
+              For example foo: bar
+                          ^^^^^^^^ some error message.
+    {%1B}     set the error message location to the type declaration of the symbol.
+              For example foo: bar
+                               ^^^ some error message.
     {%A}      abort, issue non recoverable error message (this should
               not used for internal errors).
     {%E}      error (default recoverable error).
diff --git a/gcc/m2/gm2-compiler/M2MetaError.mod b/gcc/m2/gm2-compiler/M2MetaError.mod
index 94ffdb14603..007c10b28bd 100644
--- a/gcc/m2/gm2-compiler/M2MetaError.mod
+++ b/gcc/m2/gm2-compiler/M2MetaError.mod
@@ -58,8 +58,10 @@ FROM SymbolTable IMPORT NulSym,
                         IsSubscript, IsSubrange, IsSet, IsHiddenType,
                         IsError, GetSymName, GetScope, IsExported,
                         GetType, SkipType, GetDeclaredDef, GetDeclaredMod,
-                        GetDeclaredModule, GetDeclaredDefinition, GetScope,
-                        GetFirstUsed, IsNameAnonymous, GetErrorScope ;
+                        GetDeclaredFor, GetDeclaredModule,
+                        GetDeclaredDefinition, GetScope,
+                        GetFirstUsed, IsNameAnonymous, GetErrorScope,
+                        GetVarDeclTok, GetVarDeclTypeTok, GetVarDeclFullTok ;
 
 IMPORT M2ColorString ;
 IMPORT M2Error ;
@@ -71,6 +73,8 @@ CONST
    ColorDebug = FALSE ;
 
 TYPE
+   GetTokProcedure = PROCEDURE (CARDINAL) : CARDINAL ;
+
    errorType = (none, error, warning, note, chained, aborta) ;
    colorType = (unsetColor, noColor, quoteColor, filenameColor, errorColor,
                 warningColor, noteColor, keywordColor, locusColor,
@@ -704,11 +708,23 @@ END killErrorBlock ;
                        )
                  =:
 
-   op := {'a'|'q'|'t'|'d'|'n'|'s'|'D'|'I'|'U'|'E'|'W'|'A'} then =:
+   op := {'a'|'q'|'t'|'d'|'n'|'s'|'B'|'D'|'F'|'G'|'H'|'M'|'U'|'E'|'V'|'W'|'A'} then =:
 
    then := [ ':' ebnf ] =:
 *)
 
+(*
+    {%1V}     set the error message location to the name of the symbol declared.
+              For example foo: bar
+                          ^^^  some error message.
+    {%1H}     set the error message location to the whole declaration of the symbol.
+              For example foo: bar
+                          ^^^^^^^^ some error message.
+    {%1B}     set the error message location to the type declaration of the symbol.
+              For example foo: bar
+                               ^^^ some error message.
+*)
+
 
 (*
    InternalFormat - produces an informative internal error.
@@ -1185,6 +1201,72 @@ BEGIN
 END chooseError ;
 
 
+(*
+   doErrorScopeModule -
+*)
+
+PROCEDURE doErrorScopeModule (VAR eb: errorBlock; sym: CARDINAL) ;
+VAR
+   scope: CARDINAL ;
+BEGIN
+   scope := GetScope (sym) ;
+   IF IsModule (scope)
+   THEN
+      IF IsInnerModule (scope)
+      THEN
+         doError (eb, GetDeclaredMod (sym))
+      ELSE
+         doError (eb, GetDeclaredMod (sym))
+      END
+   ELSE
+      Assert (IsDefImp (scope)) ;
+      (* if this fails then we need to skip to the outer scope.
+         REPEAT
+            OuterModule := GetScope(OuterModule)
+         UNTIL GetScope(OuterModule)=NulSym.  *)
+      IF GetDeclaredModule (sym) = UnknownTokenNo
+      THEN
+         doError (eb, GetDeclaredDef (sym))
+      ELSE
+         doError (eb, GetDeclaredMod (sym))
+      END
+   END
+END doErrorScopeModule ;
+
+
+(*
+   doErrorScopeForward -
+*)
+
+PROCEDURE doErrorScopeForward (VAR eb: errorBlock; sym: CARDINAL) ;
+VAR
+   scope: CARDINAL ;
+BEGIN
+   scope := GetScope (sym) ;
+   IF IsModule (scope)
+   THEN
+      IF IsInnerModule (scope)
+      THEN
+         doError (eb, GetDeclaredFor (sym))
+      ELSE
+         doError (eb, GetDeclaredFor (sym))
+      END
+   ELSE
+      Assert (IsDefImp (scope)) ;
+      (* if this fails then we need to skip to the outer scope.
+         REPEAT
+            OuterModule := GetScope(OuterModule)
+         UNTIL GetScope(OuterModule)=NulSym.  *)
+      IF GetDeclaredModule (sym) = UnknownTokenNo
+      THEN
+         doError (eb, GetDeclaredDef (sym))
+      ELSE
+         doError (eb, GetDeclaredFor (sym))
+      END
+   END
+END doErrorScopeForward ;
+
+
 (*
    doErrorScopeMod - potentially create an error referring to the definition
                      module, fall back to the implementation or program module if
@@ -1206,33 +1288,82 @@ BEGIN
       THEN
          doError (eb, GetDeclaredMod (sym))
       ELSE
-         IF IsModule (scope)
-         THEN
-            IF IsInnerModule (scope)
-            THEN
-               doError (eb, GetDeclaredMod (sym))
-            ELSE
-               doError (eb, GetDeclaredMod (sym))
-            END
-         ELSE
-            Assert (IsDefImp (scope)) ;
-            (* if this fails then we need to skip to the outer scope.
-            REPEAT
-             OuterModule := GetScope(OuterModule)
-            UNTIL GetScope(OuterModule)=NulSym ;  *)
-            IF GetDeclaredModule (sym) = UnknownTokenNo
-            THEN
-               doError (eb, GetDeclaredDef (sym))
-            ELSE
-               doError (eb, GetDeclaredMod (sym))
-            END
-         END
+         doErrorScopeModule (eb, sym)
       END
    END ;
    M2Error.LeaveErrorScope
 END doErrorScopeMod ;
 
 
+(*
+   doErrorScopeFor - potentially create an error referring to the
+                     forward declaration, definition module, fall back
+                     to the implementation or program module if
+                     there is no declaration in the definition module.
+*)
+
+PROCEDURE doErrorScopeFor (VAR eb: errorBlock; sym: CARDINAL) ;
+VAR
+   scope: CARDINAL ;
+BEGIN
+   scope := GetScope (sym) ;
+   IF scope = NulSym
+   THEN
+      M2Error.EnterErrorScope (NIL) ;
+      doError (eb, GetDeclaredFor (sym))
+   ELSE
+      M2Error.EnterErrorScope (GetErrorScope (scope)) ;
+      IF IsProcedure (scope)
+      THEN
+         doError (eb, GetDeclaredFor (sym))
+      ELSE
+         doErrorScopeForward (eb, sym)
+      END
+   END ;
+   M2Error.LeaveErrorScope
+END doErrorScopeFor ;
+
+
+(*
+   doDeclaredMod - creates an error note where sym[bol] was declared.
+*)
+
+PROCEDURE declaredMod (VAR eb: errorBlock; sym: ARRAY OF CARDINAL; bol: CARDINAL) ;
+BEGIN
+   IF bol <= HIGH (sym)
+   THEN
+      doErrorScopeMod (eb, sym[bol])
+   END
+END declaredMod ;
+
+
+(*
+   doErrorScopeDefinition - use the declaration in the definitio module if one is available.
+*)
+
+PROCEDURE doErrorScopeDefinition (VAR eb: errorBlock; sym: CARDINAL) ;
+VAR
+   scope: CARDINAL ;
+BEGIN
+   scope := GetScope (sym) ;
+   IF IsModule (scope)
+   THEN
+      (* No definition module for a program module.  *)
+      doError (eb, GetDeclaredMod (sym))
+   ELSE
+      Assert (IsDefImp (scope)) ;
+      IF GetDeclaredDefinition (sym) = UnknownTokenNo
+      THEN
+         (* Fall back to the implementation module if no declaration exists
+            in the definition module.  *)
+         doError (eb, GetDeclaredMod (sym))
+      ELSE
+         doError (eb, GetDeclaredDef (sym))
+      END
+   END
+END doErrorScopeDefinition ;
+
+
 (*
    doErrorScopeDef - potentially create an error referring to the definition
                      module, fall back to the implementation or program module if
@@ -1247,12 +1378,73 @@ BEGIN
    IF scope = NulSym
    THEN
       M2Error.EnterErrorScope (NIL) ;
-      doError (eb, GetDeclaredDef (sym))
+      doError (eb, GetDeclaredFor (sym))
    ELSE
       M2Error.EnterErrorScope (GetErrorScope (scope)) ;
       IF IsProcedure (scope)
       THEN
          doError (eb, GetDeclaredDef (sym))
+      ELSE
+         doErrorScopeDefinition (eb, sym)
+      END
+   END ;
+   M2Error.LeaveErrorScope
+END doErrorScopeDef ;
+
+
+(*
+   doDeclaredDef - creates an error note where sym[bol] was declared.
+*)
+
+PROCEDURE declaredDef (VAR eb: errorBlock; sym: ARRAY OF CARDINAL; bol: CARDINAL) ;
+BEGIN
+   IF bol <= HIGH (sym)
+   THEN
+      doErrorScopeDef (eb, sym[bol])
+   END
+END declaredDef ;
+
+
+(*
+   doDeclaredFor - creates an error note where sym[bol] was declared.
+*)
+
+PROCEDURE declaredFor (VAR eb: errorBlock; sym: ARRAY OF CARDINAL; bol: CARDINAL) ;
+BEGIN
+   IF bol <= HIGH (sym)
+   THEN
+      doErrorScopeFor (eb, sym[bol])
+   END
+END declaredFor ;
+
+
+(*
+   doErrorScopeProc - determine the location for the error or warning from
+                      the default declaration.  For example parameters can be
+                      declared in definition, forward or in modules (proper procedure).
+                      Use GetVarParamTok to obtain a variable or parameter location.
+*)
+
+PROCEDURE doErrorScopeProc (VAR eb: errorBlock; sym: CARDINAL;
+                            GetVarParamTok: GetTokProcedure) ;
+VAR
+   scope: CARDINAL ;
+BEGIN
+   scope := GetScope (sym) ;
+   IF scope = NulSym
+   THEN
+      M2Error.EnterErrorScope (NIL) ;
+      doError (eb, GetDeclaredDef (sym))
+   ELSE
+      M2Error.EnterErrorScope (GetErrorScope (scope)) ;
+      IF IsProcedure (scope)
+      THEN
+         IF IsVar (sym) OR IsParameter (sym)
+         THEN
+            doError (eb, GetVarParamTok (sym))
+         ELSE
+            doError (eb, GetDeclaredDef (sym))
+         END
       ELSE
          IF IsModule (scope)
          THEN
@@ -1275,36 +1467,49 @@ BEGIN
                doError (eb, GetDeclaredDef (sym))
             END
          END
-   END
+      END
    END ;
    M2Error.LeaveErrorScope
-END doErrorScopeDef ;
+END doErrorScopeProc ;
 
 
 (*
-   declaredDef - creates an error note where sym[bol] was declared.
+   doDeclaredVar - creates an error note where sym[bol] was declared.
 *)
 
-PROCEDURE declaredDef (VAR eb: errorBlock; sym: ARRAY OF CARDINAL; bol: CARDINAL) ;
+PROCEDURE declaredVar (VAR eb: errorBlock; sym: ARRAY OF CARDINAL; bol: CARDINAL) ;
 BEGIN
    IF bol <= HIGH (sym)
    THEN
-      doErrorScopeDef (eb, sym[bol])
+      doErrorScopeProc (eb, sym[bol], GetVarDeclTok)
    END
-END declaredDef ;
+END declaredVar ;
 
 
 (*
-   doDeclaredMod - creates an error note where sym[bol] was declared.
+   doDeclaredType - creates an error note where sym[bol] was declared.
 *)
 
-PROCEDURE declaredMod (VAR eb: errorBlock; sym: ARRAY OF CARDINAL; bol: CARDINAL) ;
+PROCEDURE declaredType (VAR eb: errorBlock; sym: ARRAY OF CARDINAL; bol: CARDINAL) ;
 BEGIN
    IF bol <= HIGH (sym)
    THEN
-      doErrorScopeMod (eb, sym[bol])
+      doErrorScopeProc (eb, sym[bol], GetVarDeclTypeTok)
    END
-END declaredMod ;
+END declaredType ;
+
+
+(*
+   doDeclaredFull - creates an error note where sym[bol] was declared.
+*)
+
+PROCEDURE declaredFull (VAR eb: errorBlock; sym: ARRAY OF CARDINAL; bol: CARDINAL) ;
+BEGIN
+   IF bol <= HIGH (sym)
+   THEN
+      doErrorScopeProc (eb, sym[bol], GetVarDeclFullTok)
+   END
+END declaredFull ;
 
 
 (*
@@ -1479,7 +1684,8 @@ END copySym ;
 
 
 (*
-   op := {'a'|'q'|'t'|'d'|'n'|'s'| 'u' |'D'|'I'|'U'|'E'|'W'} then =:
+   op := {'a'|'q'|'t'|'d'|'n'|'s'|'B'|'D'|'F'|'G'|'H'|'M'|'U'|'E'|'V'|'W'|'A'} then =:
+   op := {'a'|'q'|'t'|'d'|'n'|'s'| 'u' |'D'|'F'|'G'|'M'|'U'|'E'|'W'} then =:
 *)
 
 PROCEDURE op (VAR eb: errorBlock;
@@ -1501,8 +1707,12 @@ BEGIN
       'n':  doNumber (eb, sym, bol) |
       'N':  doCount (eb, sym, bol) |
       's':  doSkipType (eb, sym, bol) |
-      'D':  declaredDef (eb, sym, bol) |
+      'B':  declaredType (eb, sym, bol) |
+      'H':  declaredFull (eb, sym, bol) |
+      'V':  declaredVar (eb, sym, bol) |
+      'G':  declaredFor (eb, sym, bol) |
       'M':  declaredMod (eb, sym, bol) |
+      'D':  declaredDef (eb, sym, bol) |
       'U':  used (eb, sym, bol) |
       'E':  eb.type := error |
       'A':  eb.type := aborta ;
@@ -1536,7 +1746,7 @@ BEGIN
       '4':  InternalError ('incorrect format spec, expecting %4 rather than % spec 4')
 
       ELSE
-         InternalFormat (eb, 'expecting one of [akqtdnpsuCDEFKNOPQRSTUWXYZ:<>%]', __LINE__)
+         InternalFormat (eb, 'expecting one of [akqtdnpsuCDEFGKNOPQRSTUWXYZ:<>%]', __LINE__)
       END ;
       INC (eb.ini)
    END ;
diff --git a/gcc/m2/gm2-compiler/M2Options.mod b/gcc/m2/gm2-compiler/M2Options.mod
index e4ffa362ff3..ecdad63657c 100644
--- a/gcc/m2/gm2-compiler/M2Options.mod
+++ b/gcc/m2/gm2-compiler/M2Options.mod
@@ -617,7 +617,7 @@ END SetCheckAll ;
                   TRUE is returned.
 *)
 
-PROCEDURE SetAutoInit (value: BOOLEAN) ;
+PROCEDURE SetAutoInit (value: BOOLEAN) : BOOLEAN ;
 BEGIN
    AutoInit := value ;
    RETURN TRUE
@@ -2007,16 +2007,6 @@ BEGIN
 END GetDumpDecl ;
 
 
-(*
-   GetDumpLangGimple - return TRUE if the gimple flag is set from SetM2Dump.
-*)
-
-PROCEDURE GetDumpGimple () : BOOLEAN ;
-BEGIN
-   RETURN DumpGimple
-END GetDumpGimple ;
-
-
 BEGIN
    cflag                             := FALSE ;  (* -c.  *)
    RuntimeModuleOverride             := InitString (DefaultRuntimeModuleOverride) ;
diff --git a/gcc/m2/gm2-compiler/M2Quads.def b/gcc/m2/gm2-compiler/M2Quads.def
index d3e2118abfd..12a4708ee67 100644
--- a/gcc/m2/gm2-compiler/M2Quads.def
+++ b/gcc/m2/gm2-compiler/M2Quads.def
@@ -78,7 +78,7 @@ EXPORT QUALIFIED StartBuildDefFile, StartBuildModFile, EndBuildFile,
                  BuildBinaryOp,
                  BuildUnaryOp,
                  RecordOp,
-                 Top,
+                 Top, DupFrame,
                  PopTF, PushTF, PopT, PushT, PopNothing, PopN, PushTFA,
                  PushTtok, PushTFtok, PopTFtok, PopTtok, PushTFAtok,
                  PushTFn, PushTFntok, PopTFn,
@@ -2528,6 +2528,13 @@ PROCEDURE DisplayStack ;
 PROCEDURE Top () : CARDINAL ;
 
 
+(*
+   DupFrame - duplicate the top of stack and push the new frame.
+*)
+
+PROCEDURE DupFrame ;
+
+
 (*
    WriteOperand - displays the operands name, symbol id and mode of addressing.
 *)
diff --git a/gcc/m2/gm2-compiler/M2Quads.mod b/gcc/m2/gm2-compiler/M2Quads.mod
index 6230bf7d139..5ff0461d0d2 100644
--- a/gcc/m2/gm2-compiler/M2Quads.mod
+++ b/gcc/m2/gm2-compiler/M2Quads.mod
@@ -15618,6 +15618,22 @@ BEGIN
 END PopTF ;
 
 
+(*
+   DupFrame - duplicate the top of stack and push the new frame.
+*)
+
+PROCEDURE DupFrame ;
+VAR
+   f, newf: BoolFrame ;
+BEGIN
+   f := PopAddress (BoolStack) ;
+   PushAddress (BoolStack, f) ;
+   newf := newBoolFrame () ;
+   newf^ := f^ ;
+   PushAddress (BoolStack, newf)
+END DupFrame ;
+
+
 (*
    newBoolFrame - creates a new BoolFrame with all fields initialised to their defaults.
 *)
diff --git a/gcc/m2/gm2-compiler/M2Reserved.def b/gcc/m2/gm2-compiler/M2Reserved.def
index 7718937bdd7..1ea5fc6048b 100644
--- a/gcc/m2/gm2-compiler/M2Reserved.def
+++ b/gcc/m2/gm2-compiler/M2Reserved.def
@@ -44,7 +44,8 @@ EXPORT QUALIFIED IsReserved, tokToTok,
    AndTok, ArrayTok, BeginTok, ByTok, CaseTok, ConstTok,
    DefinitionTok, DivTok, DoTok, ElseTok, ElsifTok, EndTok,
    ExceptTok,
-   ExitTok, ExportTok, FinallyTok, ForTok, FromTok, IfTok,
+   ExitTok, ExportTok, FinallyTok, ForTok, ForwardTok,
+   FromTok, IfTok,
    ImplementationTok, ImportTok, InTok, LoopTok, ModTok,
    ModuleTok, NotTok, OfTok, OrTok,
    PackedSetTok, PointerTok, ProcedureTok,
@@ -71,7 +72,7 @@ TYPE
               arraytok, begintok, bytok, casetok, consttok,
               definitiontok, divtok, dotok, elsetok, elsiftok,
               endtok, excepttok, exittok, exporttok, finallytok,
-              fortok, fromtok, iftok, implementationtok,
+              fortok, forwardtok, fromtok, iftok, implementationtok,
               importtok, intok, looptok, modtok,
               moduletok, nottok, oftok, ortok,
               packedsettok, pointertok, proceduretok,
@@ -96,7 +97,8 @@ VAR
 
    AndTok, ArrayTok, BeginTok, ByTok, CaseTok, ConstTok,
    DefinitionTok, DivTok, DoTok, ElseTok, ElsifTok, EndTok,
-   ExceptTok, ExitTok, ExportTok, FinallyTok, ForTok, FromTok,
+   ExceptTok, ExitTok, ExportTok, FinallyTok, ForTok,
+   ForwardTok, FromTok,
    IfTok, ImplementationTok, ImportTok, InTok, LoopTok, ModTok,
    ModuleTok, NotTok, OfTok, OrTok,
    PackedSetTok, PointerTok, ProcedureTok,
diff --git a/gcc/m2/gm2-compiler/M2Reserved.mod b/gcc/m2/gm2-compiler/M2Reserved.mod
index da63ea5a16e..29ed87e4730 100644
--- a/gcc/m2/gm2-compiler/M2Reserved.mod
+++ b/gcc/m2/gm2-compiler/M2Reserved.mod
@@ -197,6 +197,9 @@ BEGIN
    ForTok := MakeKey('FOR') ;
    AddKeyword(ForTok, fortok) ;
 
+   ForwardTok := MakeKey('FORWARD') ;
+   AddKeyword(ForwardTok, forwardtok) ;
+
    FromTok := MakeKey('FROM') ;
    AddKeyword(FromTok, fromtok) ;
 
diff --git a/gcc/m2/gm2-compiler/M2Scaffold.mod b/gcc/m2/gm2-compiler/M2Scaffold.mod
index 777737ef4c0..f4f557edaf3 100644
--- a/gcc/m2/gm2-compiler/M2Scaffold.mod
+++ b/gcc/m2/gm2-compiler/M2Scaffold.mod
@@ -611,9 +611,9 @@ PROCEDURE DeclareArgEnvParams (tokno: CARDINAL; proc: CARDINAL) ;
 BEGIN
    Assert (IsProcedure (proc)) ;
    StartScope (proc) ;
-   Assert (PutParam (tokno, proc, 1, MakeKey ("argc"), Integer, FALSE)) ;
-   Assert (PutParam (tokno, proc, 2, MakeKey ("argv"), Address, FALSE)) ;
-   Assert (PutParam (tokno, proc, 3, MakeKey ("envp"), Address, FALSE)) ;
+   Assert (PutParam (tokno, proc, 1, MakeKey ("argc"), Integer, FALSE, tokno)) ;
+   Assert (PutParam (tokno, proc, 2, MakeKey ("argv"), Address, FALSE, tokno)) ;
+   Assert (PutParam (tokno, proc, 3, MakeKey ("envp"), Address, FALSE, tokno)) ;
    EndScope
 END DeclareArgEnvParams ;
 
diff --git a/gcc/m2/gm2-compiler/P0SymBuild.def b/gcc/m2/gm2-compiler/P0SymBuild.def
index e18e9c4851d..b81683eb199 100644
--- a/gcc/m2/gm2-compiler/P0SymBuild.def
+++ b/gcc/m2/gm2-compiler/P0SymBuild.def
@@ -103,6 +103,13 @@ PROCEDURE RegisterProcedure ;
 PROCEDURE EndProcedure ;
 
 
+(*
+   EndForward - ends building a forward procedure.
+*)
+
+PROCEDURE EndForward ;
+
+
 (*
    P0Init -
 *)
diff --git a/gcc/m2/gm2-compiler/P0SymBuild.mod b/gcc/m2/gm2-compiler/P0SymBuild.mod
index 2238f188a01..0939e33017c 100644
--- a/gcc/m2/gm2-compiler/P0SymBuild.mod
+++ b/gcc/m2/gm2-compiler/P0SymBuild.mod
@@ -46,7 +46,7 @@ TYPE
                      name           : Name ;
                      kind           : Kind ;
                      sym            : CARDINAL ;
-                     level          : CARDINAL ;
+                     level          : INTEGER ;
                      token          : CARDINAL ;      (* where the block starts.  *)
                      LocalModules   : List ;          (* locally declared modules at the current level  *)
                      ImportedModules: Index ;         (* current list of imports for the scanned module *)
@@ -65,7 +65,7 @@ TYPE
 VAR
    headBP,
    curBP : BlockInfoPtr ;
-   Level : CARDINAL ;
+   Level : INTEGER ;
 
 
 (*
@@ -536,6 +536,18 @@ BEGIN
 END EndProcedure ;
 
 
+(*
+   EndForward - ends building a forward procedure.
+*)
+
+PROCEDURE EndForward ;
+BEGIN
+   PopN (1) ;
+   EndBlock ;
+   M2Error.LeaveErrorScope
+END EndForward ;
+
+
 (*
    EndModule -
 *)
